#pragma once
#include "Image24.h"
#include "Primitive.h"
#include "Light.h"
#include "Material.h"
#include <vector>

class RTEngine
{
  private:
    std::vector<Primitive*> PrimitiveList;
    std::vector<Light*>     LightList;
    Vector3D Trace(Ray ray);
    
  public:
    RTEngine();
    ~RTEngine();

    void AddLight(Vector3D Position, Vector3D Color);
    void AddSphere(Vector3D Center, double Radius, Material m);
    void Render(Image24 *img);
};

