#include <stdio.h>
#include <math.h>
#include "RTEngine.h"
#include "Image24.h"
#include "Material.h"

int
main()
{
  int i;
  double x = 0.0;

  for(i = 0; i < 300; i++, x += 0.03)
  {
    char fname[256];

    Image24 Img(640, 480);
    RTEngine RT;

    Material Mat1(Vector3D(0.0, 0.0, 1.0), 0.2, 0.4);
    Material Mat2(Vector3D(1.0, 1.0, 1.0), 0.2, 0.4);
    Material Mat3(Vector3D(1.0, 0.0, 0.0), 0.2, 0.4);

    RT.AddLight(Vector3D(0.0, 0.0, -3.0), Vector3D(1.0, 1.0, 1.0));
    RT.AddLight(Vector3D(2.0, 2.0, -3.0), Vector3D(0.4, 0.0, 0.4));

    RT.AddSphere(Vector3D(sin(x) * 2,1.0,cos(x) + 2.0), 0.4, Mat1);

    RT.AddSphere(Vector3D(sin(x*2) * 2,0.0,cos(x*2) + 2.0), 0.4, Mat2);

    RT.AddSphere(Vector3D(sin(x*4) * 2,-1.0,cos(x*2) + 4.0), 0.4, Mat3);

    RT.Render(&Img);

    sprintf(fname, "anim_%.3i.tga", i);
    Img.SaveAsTGA(fname);
    putchar('.');
  }


  return 0;
}

