#pragma once

class Vector3D
{
  public:
    union
    {
      struct { double x, y, z; };
      struct { double r, g, b; };
      struct { double arr[3];  };
    };

    Vector3D();
    Vector3D(double x, double y, double z);
    void PrintVector();
    Vector3D& operator=  (Vector3D v);
    Vector3D& operator-= (Vector3D v);
    Vector3D& operator+= (Vector3D v);
    Vector3D& Set(double x, double y, double z );
    Vector3D  operator+  (Vector3D v);
    Vector3D  operator-  (Vector3D v);
    Vector3D  operator*  (Vector3D v);
    Vector3D  operator*= (Vector3D v);
    Vector3D  operator*  (double r);
    Vector3D& operator*= (double r);
    Vector3D  Cross(Vector3D v);
    double    Dot(Vector3D v);
    double    Length();
    double    SqrLength();
    void      Norm();
};

