#include <stdio.h>
#include <math.h>
#include "RTEngine.h"
#include "Image24.h"
#include "Material.h"

void AddGauge(Image24 &Img, double pos)
{
  int i, j;

  for(i = 16; i < Img.width - 16; i++)
  {
    Img.data[i + (Img.height - 48) * Img.width]      = 0x00ffffff;
    Img.data[i + (Img.height - 48 + 16) * Img.width] = 0x00ffffff;
  }

  int x = (int)((double)(Img.width - 16 - 16 - 1) * pos + 16.0);

  for(i = Img.height - 48; i < Img.height -48 + 16; i++)
  {
    Img.data[16 + i * Img.width]      = 0x00ffffff;
    Img.data[Img.width - 16 + i * Img.width] = 0x00ffffff;
  }

  for(j = 17; j < x; j++)
  {
    for(i = Img.height - 48 + 1; i < Img.height -48 + 16; i++)
    {
      Img.data[j + i * Img.width]      = 0x00aaaaaa;
    }    
  }

   


}


int
main()
{
  int i;
  double x = 0.0;

  for(i = 0; i < 160; i++, x += 0.02)
  {
    char fname[256];

    Image24 Img(320, 240);
    RTEngine RT;

    Material Mat(Vector3D(0.0, 1.0, 0.0), 0.2, 0.4, sin(x));

    RT.AddLight(Vector3D(2.0, 2.0, -3.0), Vector3D(2.0, 2.0, 2.0));

    RT.AddSphere(Vector3D(-1.0,0.0,0.5), 0.4, Mat);
    RT.AddSphere(Vector3D( 0.0,0.0,0.0), 0.4, Mat);

    RT.Render(&Img);


    AddGauge(Img, sin(x));

    sprintf(fname, "anim_%.3i.tga", i);
    Img.SaveAsTGA(fname);
    putchar('.');
  }


  return 0;
}


