/* RayTracing
 * author: gynvael.coldwind//vx (gynvael@vexillium.org)
 * An example for a lecture at wyklady.net
 * 
 * win32:
 *   g++ Image24.cpp itest.cpp -Wall -o itest.exe
 *   itest.exe
 *
 * linux:
 *   g++ Image24.cpp itest.cpp -Wall -o itest
 *   ./itest
 *
 */

#include <cmath>
#include "Image24.h"

using namespace std;

int
main(void)
{
  Image24 img(320,240);

  double f;
  for(f = 0.0; f < 50.0; f += 0.001)
  {
    int x = (int)(cos(f) * 2.0 * f ) + 320/2;
    int y = (int)(sin(f) * 2.0 * f * (0.5+fabs(sin(cos(f))))) + 240/2;
    img.data[x + y * 320] = (int)(15.0 + 240.0 * (f / 50.0)) << 8;
  }
  


  img.SaveAsTGA("dump.tga");
  

  return 0;
}

