#include <cstdio>
#include <cstring>
#include <cstdlib>
#include "Image24.h"

using namespace std;

Image24::Image24(int width, int height)
{
  this->width = width;
  this->height = height;
  this->size = width * height;
  this->data = new unsigned int[this->size];
  memset(this->data, 0, this->size * sizeof(unsigned int));
}

Image24::~Image24()
{
  if(this->data) delete this->data;
}

void
Image24::SaveAsTGA(const char *filename) const
{
#pragma pack(push,1)
struct TgaHeader
{
  unsigned char id_field;
  unsigned char c_map;
  unsigned char img_type;
  unsigned char color_map[5];
  unsigned short x_origin;
  unsigned short y_origin;
  unsigned short width;
  unsigned short height;
  unsigned char bpp;
  unsigned char flip;
};
#pragma pack(pop)

  FILE *f = fopen(filename, "wb");
  if(!f) return;

  TgaHeader header;

  memset(&header, 0, sizeof(header));
  header.img_type = 2;
  header.width  = (unsigned short)this->width;
  header.height = (unsigned short)this->height;
  header.bpp = 24;
  header.flip = 0x20;

  fwrite(&header, 1, sizeof(header), f);

  int i;
  for(i = 0; i < this->size; i++)
    fwrite(&this->data[i], 1, 3, f);  

  fclose(f);
}

