#include <stdio.h>
#include "RTEngine.h"
#include "Image24.h"
#include "Material.h"

int
main()
{
  Image24 Img(640, 480);
  RTEngine RT;

  Material PolishedStone(Vector3D(0.0, 1.0, 0.0), 0.3, 0.4, 0.9);
  Material Paper(Vector3D(1.0, 1.0, 0.8), 0.0, 0.5, 0.0);

  RT.AddLight(Vector3D(2.0, 2.0, -3.0), Vector3D(2.0, 2.0, 2.0));

  RT.AddSphere(Vector3D(1.0,0.0,0.5), 0.4, PolishedStone);
  RT.AddSphere(Vector3D(-1.0,0.0,0.5), 0.4, Paper);

  RT.Render(&Img);
  Img.SaveAsTGA("dump.tga");

  return 0;
}

