#include <math.h>
#include "PrimSphere.h"

PrimSphere::PrimSphere(Vector3D Position, double Radius)
{
  this->Position = Position;
  this->Radius = Radius;
}

int PrimSphere::Intersect(Ray &ray, double &dist)
{
  Vector3D v = ray.Origin - this->Position;
  double b = - v.Dot(ray.Direction);
  double det = (b * b) - v.Dot(v) + this->Radius * this->Radius;
  int retval = 0;
  if(det > 0)
  {
    det = sqrt(det);
    double i1 = b - det;
    double i2 = b + det;
    if(i2 > 0)
    {
      if(i1 < 0)
      {
        dist = i2;
	retval = -1;
      }
      else
      {
        dist = i1;
        retval = 1;
      }
    }
  }

  return retval;
}

